﻿#region License Information
/* HeuristicLab
 * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Linq;

namespace HeuristicLab.Problems.Instances.DataAnalysis {
  public class SocialMediaBuzzTwitter : ResourceRegressionDataDescriptor {
    public SocialMediaBuzzTwitter()
      : base("SocialMediaBuzz(Twitter).csv") { }

    public override string Name { get { return "Social Media Buzz (Twitter)"; } }
    public override string Description { get { return "This data-set contains examples of buzz events from Twitter."; } }
    protected override string TargetVariable { get { return "Mean Number of active discussion (NAD)"; } }
    protected override string[] VariableNames {
      get { return AllowedInputVariables.Concat(new[] { "Mean Number of active discussion (NAD)" }).ToArray(); }
    }
    protected override string[] AllowedInputVariables {
      get {
        return new[] {
          "Number of Created Discussions (NCD)",
          "Author Increase (AI)",
          "Attention Level (measured with number of authors) (AS(NA))",
          "Burstiness Level (BL)",
          "Number of Atomic Containers (NAC)",
          "Attention Level (measured with number of contributions) (AS(NAC)",
          "Contribution Sparseness (CS)",
          "Author Interaction (AT)",
          "Number of Authors (NA)",
          "Average Discussions Length (ADL)",
          "Average Discussions Length (NAD)"
        };
      }
    }
    protected override int TrainingPartitionStart { get { return 0; } }
    protected override int TrainingPartitionEnd { get { return 388834; } }
    protected override int TestPartitionStart { get { return 388834; } }
    protected override int TestPartitionEnd { get { return 583250; } }
  }
}